<?php
/**
 * FeedGeorge main class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2011 FeedGeorge.com
 * @access public
 */
 
class WP_FG_Ajax {
    private $apikey;
    private $apiurl;
    
    function __construct() {
        $this->apiurl = FG_SITE . 'api/source.json?';
    }
    
    function call_ajax() {
		
		
        $ne = trim($_REQUEST['ne']);
        $sw = trim($_REQUEST['sw']);
        $cat = trim($_REQUEST['c']);
		$cat1 = trim($_REQUEST['c2']);
		$limit = trim($_REQUEST['l']);
		
		$dateperiod = trim($_REQUEST['d']);
		
        //$p = trim($_REQUEST['p']);
		$postid = trim($_REQUEST['i']);
		$catarr = split(',',$cat1);
		if (!empty($cat1)) $cat = get_subcats($cat1,$cat);
		
        if (preg_match('/^[-0-9,.]+$/',$ne) && preg_match('/^[-0-9,.]+$/',$sw)) {
            $r1['markers'] = array();
            //if (empty($cat)) $cat = '1,2,7,32,37,3,4,5,25,33,34,9,10,11,13,14,15,16,17,18,19,20,21,22,23,24,27,31,35,36,29,38,30,28,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53';
            
	     //if (isset($p) && !empty($p)) 
		 if (in_array('1',$catarr))
			$nearbyposts = $this->find_nearbyStory($p,$ne,$sw,$postid);
		 
         $r = json_decode($this->post_request($ne,$sw,$cat,$dateperiod,$limit),true);
		 
		if (isset($r) && !isset($r['error'])) {
				$r1['markers'] = $r['source'][0]['markers'];
				if (count($nearbyposts) > 0) {
					
					foreach($nearbyposts as $post) {	
					array_push($r1['markers'],$post);
					}
				}
               
                $this->print_output(json_encode($r1));
            }
			else if (isset($nearbyposts) && count($nearbyposts) > 0) {
				
				foreach($nearbyposts as $post) {
					array_push($r1['markers'],$post);
				}
				$this->print_output(json_encode($r1));
			}
            else
                $this->print_output(json_encode('-2'));
        }
        else {
            $this->print_output(json_encode('-1'));
        }
        exit;
    }
	
	
	function find_nearbyStory($p,$ne,$sw,$postid) {
		global $post,$wpdb;
		$current_id = $postid;
		
		list($lat1,$long) = split(',',$p);
		//list($lat,$lon) = split(',',$ne);
		list($nelat,$nelon) = split(',',$ne);
		list($swlat,$swlon) = split(',',$sw);
		
		//$radius = getDistance($lat1,$long,$lat,$lon);
		
		$icon = 'http://chart.googleapis.com/chart?chst=d_map_xpin_letter_withshadow&chld=pin_star||FA5882|0000FF|FFFF00&.png';
		//$icon = get_bloginfo('template_directory') . '/images/cjmy_map_marker.png';
		
		/*$args = array(
					'posts_per_page' => 50,
					'post_status' => 'publish',
					'meta_query' => array(
						array(
							'key' => 'geo_latitude',
							'value' => $nelat,
							'type' => 'NUMERIC',
							'compare' => '<'
						),
						array(
							'key' => 'geo_latitude',
							'value' => $swlat,
							'type' => 'NUMERIC',
							'compare' => '>'
						),
						
						array(
							'key' => 'geo_longitude',
							'value' => $nelon,
							'type' => 'NUMERIC',
							'compare' => '<'
						),
						array(
							'key' => 'geo_longitude',
							'value' => $swlon,
							'type' => 'NUMERIC',
							'compare' => '>'
						),
					)
				 );
		
		$the_query = new WP_Query( $args);
		*/
		//$posts =  get_posts(array('numberposts' => 100,'post_type' => 'post','post_status' => 'publish'));
		$sql = '
		SELECT  mt1.meta_value as lat,mt2.meta_value as lng,wp_posts.post_title,wp_posts.ID,wp_posts.post_date_gmt FROM wp_posts  INNER JOIN wp_postmeta ON (wp_posts.ID = wp_postmeta.post_id)
		INNER JOIN wp_postmeta AS mt1 ON (wp_posts.ID = mt1.post_id)
		INNER JOIN wp_postmeta AS mt2 ON (wp_posts.ID = mt2.post_id)
		INNER JOIN wp_postmeta AS mt3 ON (wp_posts.ID = mt3.post_id) WHERE  wp_posts.post_type = "post" AND (wp_posts.post_status = "publish")  AND ( 
		(wp_postmeta.meta_key = "geo_latitude" AND wp_postmeta.meta_value  < %s)
		AND  (mt1.meta_key = "geo_latitude" AND  mt1.meta_value  > %s)
		AND  (mt2.meta_key = "geo_longitude" AND mt2.meta_value < %s)
		AND  (mt3.meta_key = "geo_longitude" AND mt3.meta_value  > %s) ) GROUP BY wp_posts.ID ORDER BY wp_posts.post_date DESC LIMIT 0, 50';

		$posts = $wpdb->get_results($wpdb->prepare($sql,$nelat,$swlat,$nelon,$swlon));
		
		$points = array();
		
		foreach($posts as $post1) {
	    
		//while ( $the_query->have_posts() ) : 
			
			//$latitude = get_post_meta($post1->ID, 'geo_latitude',true);
			//$longitude = get_post_meta($post1->ID, 'geo_longitude',true);
			$latitude = $post1->lat;
			$longitude = $post1->lng;
			
			if (is_numeric($latitude) && is_numeric($longitude) && $post1->ID != $current_id ) {
				//$distance = getDistance($latitude,$longitude,$lat1,$long);
				
				//if ($distance <= $radius) {
					$point = array(
						'id1' => '['.$current_id.']',
						'name' => $post1->post_title,
						'title' => $post1->post_title,
						'summary' => '' ,
						'url' => get_permalink($post1->ID),
						'lat' => $latitude,
						'lng' => $longitude,
						'icon' => $icon,
						'entry_id' => $post1->ID,
						'created_at' => $post1->post_date_gmt, 
						'published_date' => $post1->post_date_gmt,
					);
					array_push($points,$point);  
					
				//}
			}
		
		}
		
		return $points;
	}
	
	
	
	function save_poly() {
	    
		$var = $_REQUEST['m'];
	    
		if (isset($var)) {
		  parse_str($var,$post );
		  
		  if ($this->write_post($post)>0) {
			$this->print_output(1);
		  }
		  else
			$this->print_output(-1);
		}
		else
			$this->print_output(-1);
			
		exit;
	}
	
	
	function write_post($post) {
        global $current_user;
		
		if (!current_user_can( 'edit_posts' ))  {
            return -1;
        }
		
        $user_id = $current_user->ID;
		
        $post_title = $post['ptitle'];
        $post_content = $post['pdesc'];
        $post_type = 'post';
		$post_kml = $post['fgkml'];
		//$post_kml = $this->generate_kml($post);
		$post_data = $_POST['p'];
		$post['fgkmlfile'] = $_POST['f'];
        $post_id = wp_insert_post( array( 'post_title' => $post_title, 'post_content'=>$post_content,'post_type' => $post_type, 'post_status' => 'publish' ) );
        if (!$post_id) {
            return -1;
        }
		
		if (isset($_FILES['fgkmlfile']) && is_uploaded_file($_FILES['fgkmlfile']['tmp_name'])) {
			$this->moveKmlFile($post_id,$_FILES['fgkmlfile'],$post_data);
		}
		else {
			add_post_meta($post_id, FGEORGE_KMLFILE, array('kml'=>$post_kml,'styles'=>$post_data['styles'],'points'=>$post_data['points']));
			$this->uploadkmlfile($post_id);
		}
        return $post_id;
    }
	
	
	function uploadkmlfile($post_id) {
		$uploads = wp_upload_dir();
		$kml = get_post_meta($post_id, FGEORGE_KMLFILE,true);
		
		if(!file_exists($uploads['basedir'] . FG_KML_DIR)) {
			mkdir($uploads['basedir'] . FG_KML_DIR);
		}
		
		$kmlfile = $uploads['basedir'] . FG_KML_DIR .'/wpfg_'. $post_id .'.kml';
		
		if($fs = fopen($kmlfile,'w')) {
			if(!fwrite($fs, trim($kml['kml'])))
				return false;
				
			fclose($fs);
			
			return true;
		}
		else
			return false;
		
	}
	
	
	function moveKmlFile($post_id,$FILE,$post_data) {
		
		$uploads = wp_upload_dir();
		
		if (is_uploaded_file($FILE['tmp_name'])) {
		   if(!file_exists($uploads['basedir'] . FG_KML_DIR)) {
			mkdir($uploads['basedir'] . FG_KML_DIR);
		   }
		
		   $kmlfile = $uploads['basedir'] . FG_KML_DIR .'/wpfg_'. $post_id .'.kml';
		   
		   $tmp_name = $FILE['tmp_name'];
		   $name = $FILE['name'];
           move_uploaded_file($tmp_name, $kmlfile);
		   $post_kml = file_get_contents($kmlfile); 
		   add_post_meta($post_id, FGEORGE_KMLFILE, array('kml'=>$post_kml,'styles'=>$post_data['styles'],'points'=>$post_data['points']));
		   
		}
	}
	
	function exportKMLFile() {
		header('Content-Type: application/vnd.google-earth.kml+xml kml; charset=utf8');
        header('Content-Disposition: attachment; filename="kmlfile.kml"');
        header('Cache-Control: no-cache, must-revalidate');
        //header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		
		$kml = stripslashes(trim($_POST['fgkmlexport']));
		echo $kml;
		exit;
	}
	
	
	function readKMLFile() {
		if (isset($_FILES['fgkmlfile']) && is_uploaded_file($_FILES['fgkmlfile']['tmp_name'])) {
			//$_FILES['fgkmlfile']
			$tmp_name = $_FILES['fgkmlfile']['tmp_name'];
			
			$post_kml = file_get_contents($tmp_name);
			$this->print_output($post_kml);
		}
		
		
		exit;
	}
	
    
    function print_output($msg) {
        header('Content-Type: text/plain; charset=utf-8');
        echo $msg;
    }
    
    function post_request($ne,$sw,$cat,$dateperiod,$limit) {
        global $fg_geo;
        
        $options = $fg_geo->get_options();
        $apikey = $options['feedgeorge_key'];
		
		$dateduration = 730;
		$limitq  = '';
		
		if ($dateperiod > 0) {
			$dateduration = $dateperiod;
		}
		
		if ($limit >= 10) {
			$limitq = '&l=' . $limit;;
		}
		
        if (!empty($apikey)) {
            $url_with_get = $this->apiurl .'ne='.$ne.'&sw='.$sw.'&sc='.$cat.'&s=&page=1&d='.$dateduration.$limitq.'&sr=undefined&_=1294294811675&key=' . $apikey;
            
			$result = file_get_contents($url_with_get);
			
			/*$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url_with_get);
			//curl_setopt($ch, CURLOPT_POSTFIELDS, $post_string);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch,CURLOPT_FOLLOWLOCATION,true);
			//curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			$result = curl_exec($ch);
			
			curl_close($ch);*/
			//$array = json_decode($result);
			
        }
        return $result;
    }
	
	
	function generate_kml($post) {
	
	$post_data = $_POST['p'];
	$points = '';
	if (isset($post_data['points']) && count($post_data['points']) > 2) {
		for($i=0; $i<count($post_data['points']); $i++) {
			list($lat,$lng) = split(',',$post_data['points'][$i]);
			$points .=  $lng .','. $lat . ',0 ' . "\n";
		}
	}
	
$kml = '
<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2">
<Document>
<name><![CDATA[ '.$post['ptitle'].' ]]></name>
<description><![CDATA[ '.$post['pdesc'].' ]]></description>
'.$post_data['styles'].'
<Placemark>
	<name><![CDATA[ '.$post['ptitle'].' ]]></name>
	<description><![CDATA[ '.$post['pdesc'].' ]]></description>
	<styleUrl>#fgpolyStyle</styleUrl>
	<Polygon>
		<extrude>1</extrude>
		<altitudeMode>relativeToGround</altitudeMode>
		<outerBoundaryIs>
			<LinearRing>
				<coordinates>
				'.$points.'
				</coordinates>
			</LinearRing>
		</outerBoundaryIs>
	</Polygon>
</Placemark>
</Document>
</kml>
';

return $kml;
	
	}
    
}


?>